EM <-
function(y, K, init="quantile", family="Gaussian", iter=-1,  threshold = 0.0001,  lambda=0.999, tol=0.5, verbose=FALSE, plot=FALSE,...) {

       if (is.vector(y) || is.ts(y)){
                 y<-matrix(y, length(y),1)
       }  

       if(is.list(init)){
          sp <- init
       } else if (init=="shortruns"){
          sp <- init(y,K, type="shortruns",  family=family,  maxit=50, threshold = 10,   lambda=lambda, plot=plot, verbose=verbose)
       } else {
          sp <- init(y,K, type=init, tol=tol)        
       }   
       
       d = dim(y)[2]
       if (family=="Gaussian" && d==1){
            family="1dGaussian"
       }  
       theta <- sp
       theta$family <- family
       
      # if (theta$family=="Cauchy"){sp$Sigma <- as.list(rep(0.5*IQR(y), K))}
       
       if (iter==-1){iter<-10^5} else if (threshold <1) {threshold <- 10^(-8)} ## we don't want this option for shortruns


	  # EM iterations:
	  i = 1
    W = estep (theta,y)
    if (plot){
        plot.umix(theta,y,  ...)
    }
  # print(W[1,])
	convergedOld = 999
	converged = 0
	ll = NULL
 #   require(mvtnorm)

	while ( (abs(converged - convergedOld) > threshold) && (i<=iter)) {

           if (verbose) {
                   cat(i, "..")
           }
           convergedOld = converged
           
           theta = mstep(y, W, lambda, family)
           #print(theta)
           W     = estep(theta, y)
          
           if (plot){ 
                plot.umix(theta, y, ...)
           }
          
            ll[i] = converged = logLike(theta, y)
           
            i = i + 1              
	}

	theta$W = W
	theta$ll = ll
	theta$sp = sp
        theta$iter=i-1
        theta$y=y
        theta$family=family

        if (verbose) {
                   cat("\n")
              }

        class(theta) <- "umix"
	return (theta)
}
