UEM <-
function(y, K,  init="quantile",  split=NULL,  randomize=FALSE, family="Gaussian", iter=-1,  threshold=0.001, max.time=NULL, lambda = 0.999,  verbose=FALSE, plot=FALSE,...) {

   t0<-Sys.time()
   
    if (is.vector(y)){
      y<-matrix(y, length(y),1)
    } else if (!is.matrix(y)){
      y<-as.matrix(y)
    }  
  
    n<- dim(y)[1]
    d<- dim(y)[2]

    
    if(randomize){
      r<-sample.int(n, n, replace=FALSE)
      y<-matrix(y[r,],n,d)
    }    
    
     if (verbose) {
                   cat("(", 1, ")", "..")
              }

    
    i=0
    if (is.null(split)){ 
          fit<- EM(y,K, init=init, family=family, iter=iter, threshold=threshold,  lambda=lambda, plot=plot, verbose=verbose, ...)
    i<-i+fit$iter      
    } else  if (!length(iter)%in%c(1,(length(split))+1)) {
          stop("iter needs to have length 1 or 'length(split)+1'")
    } else {
       split<-c(split,n)
       S <-length(split)
       L <- LU<-NULL ## to store log-liks
       
       if (length(iter)==1){
           iter<- rep(iter, S)
      }
       
      fit<-fit0<- EM(y[1:split[1],], K, init=init,  family=family, iter=iter[1],threshold=threshold, lambda=lambda,   verbose=verbose, plot=plot, ...)
      theta<-fit
      i<- i+fit$iter        
      LU[1]<- tail(fit$ll, n=1)
      L[1]<-  logLike(fit,y)
      # print(L[1])
      allmu<-list()
      allmu[[1]]<-fit$mu 
      allpi<-list()
      allpi[[1]]<-fit$pi 


       
      for (j in 2:S){

              
              if (verbose) {
                   cat("(", j, ")", "..")
              }

             if (split[j]>split[j-1]){ 
                     datz<-  y[(split[j-1]+1):(split[j]),]
             } else {
                    datz<-NULL
             }       
             daty<-  y[(1:split[j-1]),]
             if (!is.null(max.time)){ 
                 t1<-Sys.time()
                 diff<-as.numeric(t1-t0, unit="secs") 
                 if ( diff>max.time){
                           L[j]<-  logLike(fit,y)
                           break
                  }
               
                  if (iter[j]!=-1){                  
                     fit<- updateEM(datz, theta=theta,  iter=iter[j], max.time=max.time-diff,lambda=lambda, plot=plot, verbose=verbose, ...)      
                  } else {         
                     fit<- updateEM(datz, theta=theta, threshold=threshold, max.time=max.time-diff, lambda=lambda, plot=plot, verbose=verbose, ... )
                  }
             } else {
                  if (iter[j]!=-1){                  
                     fit<- updateEM(datz, theta=theta, iter=iter[j], lambda=lambda, plot=plot, verbose=verbose, ... )      
                  } else {         
                     fit<- updateEM(datz, theta=theta, threshold=threshold, lambda=lambda, plot=plot, verbose=verbose, ... )
                  }
             }       
                 
             i<-i+fit$iter
            
             L[j]<-  logLike(fit, y)
           
             LU[j]<- ifelse(length(fit$llu>1), tail(fit$llu,n=1),LU[1])             
             allmu[[j]]<-fit$mu
              allpi[[j]]<-fit$pi 
             theta<-fit
            
        
      }

      fit$ll<-L
      fit$llu<- LU
      fit$allmu<-allmu
      fit$allpi<-allpi
      fit$iter=i
      fit$y=y 
      fit$usteps=j
   }
    if (verbose) {
                   cat("\n")
              }
    
   class(fit)<-"umix" 
   return(fit)
}
