contours.umix <-
function(theta, y,...){
    
  xpts = seq(min(y[,1]) - 0.5 * sd(y[,1]), max(y[,1]) + 0.5 * sd(y[,1]), length = 100)
  
  ypts = seq(min(y[,2]) - 0.5 * sd(y[,2]), max(y[,2]) + 0.5 * sd(y[,2]), length = 100)
 
  mixture.contour <- outer(xpts,ypts,function(a,b) {
     
   K = length(theta$mu[,1])
   r = rep(0, length(a))
                                            
   for (k in 1:K)
     
       r = r + theta$pi[k]*mvtnorm::dmvnorm(cbind(a,b),mean=theta$mu[k,],sigma=theta$Sigma[[k]]) 
       
       return (r)
  })
 
    contour(xpts,ypts,mixture.contour,nlevels=20, lty = "solid",drawlabel=FALSE,col=terrain.colors(25), ...)
  
}
