draw1d.umix <-
function(theta, showMeans=TRUE,  ...){

  mu   <- as.numeric(theta$mu)
  pi   <- theta$pi
  sigma<- sqrt(as.numeric(theta$Sigma))
                 
  K<-length(pi)      
  
  mu0<- mu
  mu<-mu[order(mu0)];  sigma<- sigma[order(mu0)];  pi<- pi[order(mu0)]

 
  r<-c(0,0) 
  if (!is.null(theta) &&  !is.null(theta$y)){
    r<- range(theta$y)
  } else {
    r<- c(mu[1],mu[K])
  }

    if (theta$family %in% c("Gaussian","1dGaussian")){
      
  rangemix  <- seq(min(r[1],mu[1]- 4*max(sigma[1], sigma[2])), max(r[2],mu[K]+4*max(sigma[K-1],sigma[K])), length=400)
  densmix   <- matrix(0,K, length(rangemix))
  for (j in 1:K){
     densmix[j,] <-  pi[j]*dnorm(rangemix,mu[j],sigma[j])
  }   
  dens<- apply(densmix, 2, sum)

       plot(rangemix, dens, ylim=c(0, max(dens)), type="l", xlab="x", ylab="f(x)",  ...)
  
     }  else if (theta$family=="Poisson")  {
      plot(table(theta$y))
     } 

  if (theta$family=="Gaussian"){
    for (j in 1:K){
      #print(j)
      lines(rangemix, densmix[j,], col="grey50")
    }
    lines(rangemix,dens)
  }  
  
  if (showMeans){
		points(mu, rep(0,K), col='tomato',
                       #cex=0.01*max(dens)*sqrt(pi),
                       cex=4*sqrt(pi), pch=16)
              }

  output<-switch(theta$family,
               "Gaussian"=   cbind(rangemix,dens),
               "Poisson"= table(theta$y)
           )      
  
  invisible(output)

}
