draw2d.umix <-
function (theta, y,   i, j,showMeans=TRUE, col, ...) {

	g = c(i,j)
	xpts = seq(min(y[,i]) - 0.5 * sd(y[,i]), max(y[,i]) + 0.5 * sd(y[,i]), length = 100)
	ypts = seq(min(y[,j]) - 0.5 * sd(y[,j]), max(y[,j]) + 0.5 * sd(y[,j]), length = 100)
	# k = length(theta$pi)
	Sigma = theta$Sigma
  #      sigma = sigma[g,g]
  K = length(theta$mu[,1])
	mixture.contour <- outer(xpts,ypts,function(a,b) {
		r = rep(0, length(a))
		for (k in 1:K) 
			r = r + theta$pi[k]*mvtnorm::dmvnorm(cbind(a,b),mean=theta$mu[k,g],sigma=Sigma[[k]][g,g]) 
		return (r)
		})
	contour(xpts,ypts,mixture.contour,nlevels=20, lty = "solid",drawlabel=FALSE,col=terrain.colors(25),  main="")
	#image(xpts,ypts,mixture.contour,nlevels=25,col=terrain.colors(25),xlab="x",ylab="y",main="")
	points(y[,g], col=col)
       # print(theta$mu[,g])
        if (showMeans){
          for (k in 1:K){
		points(theta$mu[k,i],theta$mu[k,j],  col='tomato',
                       #cex=0.01*max(dens)*sqrt(pi),
                       cex=6*sqrt(theta$pi[k]), pch=16)
              }
        }
	
}
