init <-
function (y, K, type="quantile", tol=0.5, ...) {
# other types: random, bad, shortruns, quantile, gq

       if (is.vector(y) || is.ts(y)){
                 y<-matrix(y, length(y),1)
       } 
       n = length(y[,1])
       d = length(y[1,])
       m = matrix(0, ncol=d, nrow=K)
       s = list()

       if (type=="shortruns"){
           sp=shortruns(y,K,  ...)
        } else {
            Sigma <- cov(y)   
            if (type %in%c("gq", "sd")){
                    # sdev<-rep(0,d)
                    tmp <- npmlreg::gqz(K, minweight = 1e-50)
                    ym  <- apply(y,2,mean)
                    z  <- -tmp$location
                    kseq<- 0
                    if  (K %%2==0){kseq<- seq(-K/2, K/2, length=K)} else {kseq<- seq(-(K-1)/2, (K-1)/2, length=K)}
                    
                    if (type=="gq"){
                        pi<- tmp$weight    
                        for (j in 1:d) { 
                                m[,j] <- ym[j] + tol * sqrt(Sigma[j,j]) * z      
                        }
                    } else if (type=="sd"){
                         pi = rep(1/K, K)   
                         for (j in 1:d) { 
                                m[,j] <- ym[j] + tol * sqrt(Sigma[j,j]) * kseq 
                        } 
                    }            
             }  else {          
	     pi = rep(1/K, K)
	     for (i in 1:K) {
                if (type=="random"){
                    sam<- sample(n,K)
                    m<-as.matrix(y[sam,])
              } else if (type=="scatter"){ 
		    for (j in 1:d) {
			m[i,j] = runif(1, min(y[,j]), max(y[,j]))
		   }
           
              } else if (type=="bad"){
                    for (j in 1:d) {
			m[i,j] = runif(1, min(y) - (2*abs(min(y))), max(y) + (2*max(y)))
                      }     
              } else {# type="quantile"
               for (j in 1:d) {
		  	m[i,j] = quantile(y[,j], probs = i/K-1/(2*K))
                      }
             } 
              
              }
           }
           for (i in 1:K) {
              # Full Sigma
              ## Sigma<- cov(y)
                s[[i]]<- Sigma
            }
            
              # l = length(s) + 1 # Diagonal Sigma  # s[[l]] = diag(apply(y, 2, var))    # global sigma    
              sp=list("pi"=pi, "mu"=m, "Sigma"=s)
          }
	      return(sp)
}
