logLike <-
function(theta, y) {
      if (is.vector(y) || is.ts(y)){
          y<-matrix(y,ncol=1)
          theta$mu<- matrix(theta$mu,ncol=1)
        }  

        K<-length(theta$pi)
       
       if(is.null(theta$family)){
         if (!is.null(theta$Sigma)){
           if (dim(theta$mu)[2]==1){
             theta$family<-"1dGaussian"
           } else {
             theta$family<-"Gaussian"
          }   
         } else {
           theta$family<- "Poisson"
         }  
        }   
	dens <- matrix(0,dim(y)[1], K)
       
	for (k in 1:K){
          dens[,k]<- switch(theta$family,
                  "1dGaussian"=  theta$pi[k] *dnorm(y,  mean=theta$mu[k,], sd=sqrt(theta$Sigma[[k]])),          
                  "Gaussian"=theta$pi[k] * dmvnorm(y, mean=theta$mu[k,], sigma=theta$Sigma[[k]]),
                                
                 "Poisson"=   theta$pi[k] * dpois(y, lambda=theta$mu[k]),
                 "Cauchy"=   theta$pi[k] * dcauchy(y, location=theta$mu[k,], scale=theta$Sigma[[k]] )
                 )
        }
       
	loglik<- sum(log(apply(dens,1,sum)))
                
   return (loglik)   
}
