mstep <-
function (y, W, lambda, family="Gaussian") {

       if (is.vector(y)){
          y<-matrix(y,ncol=1)
        }  
          
	d = length(y[1,])
	n = dim(W)[1]
	K = dim(W)[2]
	pi = apply(W, 2, sum)/n
       	
	m = matrix(0, ncol=d, nrow=K)
	s = list()
	var<-NULL  
	
	#if (family!="Cauchy"){
	  
	  for (j in 1:K) {
		  for (i in 1:d) {                                     
			  m[j,i] = sum(W[,j]*y[,i]) / sum(W[,j])
		  }
    }
    
    if (family %in%c("Gaussian", "1dGaussian") ){
	     for (k in 1:K) {		
	       	s[[k]] = cov.wt(y, W[,k])$cov
      }
      wk = dkern2(K, lambda)
	    s2 = wtSigma(s, wk, K)
      var <-s2         
    }
	#} else if (family=="Cauchy"){
  #  for (k in 1:K){
  #    m[k,1]<- weighted.quantile(y,W[,k],0.5)
  #    s[k]<-0.5*(weighted.quantile(y,W[,k],0.75)-weighted.quantile(y,W[,k],0.25))
  #  }
	#  var<-s
	#  #print(var)
	#}
	
  output<- list(pi=pi, mu=m, Sigma=var, family=family)
  #print(output)   
                  
	return(output)
          ### Note: s2 is the covariance matrix, that is in 1D these are VARIANCES.
          
}



