plot.umix <-
function(x, y=NULL,  showMeans=TRUE, contours= TRUE, col='cornflowerblue',...){
    
        if(missing(y)){
             if (is.null(x$y)){stop("Data (y) need to be provided either as argument of plot.umix or as a component of x.")}
               y<-x$y             
           }

       if (is.null(x$y)){
           x$y<-y
         }  
       
        if (is.vector(y) || dim(y)[2] == 1){
          
           draw1d.umix(x, showMeans=showMeans,...)
          
           if (x$family!="Poisson"){rug(jitter(y,factor=0.5), col=col)}
        
        } else if (dim(y)[2] == 2) {

      
            if (contours){
             
             contours.umix(x,y,...)
            
             points(y, col=col, pch=16)
             
                   } else {
                      plot(y, col=col, pch=16,... )
                   }
                
		if (showMeans){
			points(x$mu, col='tomato', cex=5*sqrt(x$pi), pch=16)
                }
           
	} else { 
		d = dim(y)[2]
		par(mar=c(1.5,2.5,0.3,0.3), mfrow=c(d, d), mgp=c(3,0.5,0))
		for (i in 1:d) {
			for (j in 1:d) {
				if (i == j)
					plot(y[,i],col=col,...)
				else {
					draw2d.umix(x,y,  i, j, col=col,...)
				}
			}
		}
		
	}
}
