updateEM <-
function(z=NULL, theta,  iter=-1,  threshold=0.001, max.time=NULL, lambda = 0.999,verbose=FALSE, plot=FALSE,... ) {
      
     t0<-Sys.time()
     d<- dim(theta$mu)[2]
     y<-theta$y
     family<-theta$family
     r<-iter
     if (is.vector(y)){
           if (d==1){
               y<-matrix(y, ncol=1)
            } else {    
           y<-matrix(y, nrow=1, ncol=d)
           }
      }
     
      if (is.vector(z)){
           if (d==1){
               z<-matrix(z, ncol=1)
            } else {    
           z<-matrix(z, nrow=1, ncol=d)
           }
      }

     if (missing(r)|| r==-1){r<-10^5} else {threshold <- 10^(-6)}

    K      <- length(theta$pi)
    lltemp <- theta$ll           # keep the loglike from TEM

    y  <- rbind(y, z)              # combine the data from TEM and UEM
        
    ll <- NULL
    convergedOld<-0
    #col=rpois(1,5)
    if (plot && d==2 && dev.cur()>1){
            points(z, col='cornflowerblue', pch=16)      # plot new points
        }    

     if (verbose) {
                   cat(0, "..")
             }

      ### mini update -step (r=0)
       
       if (is.null(z)){
             W<- theta$W
          } else {
      	     Wz = estep(theta, z)          # compute W' matrix for the new points using the theta from TEM 
             W  = rbind(theta$W, Wz)       # combine the W from TEM and UEM
       } 
      
       ll[1]<- converged<- logLike(theta,y)
       j<-1
        
       if (r>=1){ while( (abs(converged - convergedOld) > threshold)&& (j <=r)){
                if (verbose) {
                     cat(j, "..")
                }
                t1<-Sys.time()
              
                if (!is.null(max.time)){
                  diff<-as.numeric(t1-t0, unit="secs")
                  if ( diff>max.time){
                     ll[j+1]<- logLike(theta, y)
                     break 
                  }
                }
                convergedOld <- converged
             	
	        theta <- mstep (y, W, lambda, family)  # M step
                W     <- estep (theta, y)      # E step
                ll[j+1]<- converged <- logLike(theta, y)
                if (plot){
               
                  plot.umix(theta,y,showMeans=TRUE, contours= TRUE, col='cornflowerblue', ...)                             
                }
                j=j+1
               
              }
    }

    theta$W   = W				  # save the W matrix
    theta$iter <- j-1
    #ll<-tail(ll, n=1)
    theta$ll  = c(lltemp, ll)     # combine the loglik from previous TEM and the new UEM
    theta$llu = ll                # save just the loglik from UEM
    theta$y=y
    theta$family<-family

    if (verbose){
      cat("\n")
    }
    class(theta)<-"umix" 
    return (theta)
}
