\name{energy1}
\alias{energy1}
\alias{energy2}
\docType{data}
\title{
Energy use data
}
\description{
Energy use data set
}
\usage{
data("energy1")
data("energy2")
}
\format{
  \code{energy1} is a data frame giving the energy use (kg of oil equivalent per capita)
  for 134 countries for the years 1971 to 2011. \code{energy2} is
  a log10 version of the original data frame. 
}
\details{
Energy use refers to use of primary energy before transformation to other end-use fuels, which is equal to indigenous production plus imports and stock changes, minus exports and fuels supplied to ships and aircraft engaged in international transport.
%%  ~~ If necessary, more details than the __description__ above ~~
}
\source{
Source: International Energy Agency.
Catalog Source: World Development Indicators.
%%  ~~ reference to a publication or URL from which the data were obtained ~~
}
\references{
Qarmalah, Najla M. and Einbeck, Jochen and Coolen, Frank P.A. (2018) 'k-Boxplots for mixture data.', Statistical papers., 59 (2). pp. 513-528.
}
\examples{
data(energy2)
boxplot(energy2[,c(1,6,11,16,21,26,31,36,41)],xlab="year",ylab="log energy use")
}
\keyword{datasets}
