\name{gaussSim}
\alias{gaussSim}
\alias{gaussSimN}
\alias{poisSim}
\alias{poisSimN}
\alias{cauchSim}
\alias{cauchSimN}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Simulating from mixture models
}
\description{
Functions to simulate data from Gaussian, Poisson, and Cauchy mixtures.
}
\usage{
gaussSim(theta)
gaussSimN(n, theta)
poisSim(theta)
poisSimN(n, theta)
cauchSim(theta)
cauchSimN(n, theta)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{theta}{
a list with elements \code{pi} (vector of mixture proportions), \code{mu} (a matrix where each row is one mean vector), and \code{Sigma} (a list of as many variance matrices as mixture components). In the case of the Cauchy model, \code{Sigma} is a list of gamma parameters.
}
 \item{n}{
sample size
}
}

\author{
J. Einbeck, D. Bonetti, Z. Kalantan
}



%\seealso{
  %% ~~objects to See Also as \code{\link{help}}, ~~~

%% ~Make other sections like Warning with \section{Warning }{....} ~
  
%}
\examples{
rho   <-0.7 
Sigma <- list(diag(c(1,2)), matrix(c(2, 2*rho, 2*rho, 1), byrow=TRUE, ncol=2))
theta <-list(pi=c(1/3, 2/3), mu=matrix(c(3,1,0,4), byrow=TRUE, ncol=2), Sigma=Sigma)
sim  <- gaussSimN(1000, theta)

fit2 <- EM(sim, K=2)
plot.umix(fit2)

sim1 <- cauchSimN(100,theta=list(pi=rep(0.5,2), mu=c(0,20), Sigma=list(gamma=1, gamma=2)))
hist(sim1, breaks=40)

}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{mixtures}
\keyword{simulation}% __ONLY ONE__ keyword per line
